:- use_module(library(lists), [permutation/2]).

% Kif a MuvL listabeli mveletekkel az L listban megadott
% szmokbl felptett kifejezs, amelynek rtke Ertek.
kif(L, MuvL, Ertek, Kif) :-
	permutation(L, PL),
	levelek_muv_kif(PL, MuvL, Kif),
	catch(Kif =:= Ertek, _, fail).

% levelek_muv_kif(+L, +MuvL, ?Kif): A MuvL listabeli mveletekkel felptett Kif
% kifejezs leveleiben lev szmok listja L.
levelek_muv_kif(L, _MuvL, Kif) :-
	L = [Kif], number(Kif).
levelek_muv_kif(L, MuvL, Kif) :-
	append(L1, L2, L),
	L1 \= [], L2 \= [], 
	levelek_muv_kif(L1, MuvL, K1),
	levelek_muv_kif(L2, MuvL, K2),
	member(M, MuvL),
	Kif =.. [M,K1,K2].


kif_1346(E) :-
	kif([1,3,4,6], [+,-,*,/], E, Kif),
	write(Kif), nl,
	fail.
kif_1346(_).
